Foreman - Bug #13168

Rendering of kickstart_networking_setup fails: undefined method ‘each’ for Safemode::Jail
(ActiveRecord::AssociationRelation)

01/13/2016 03:43 AM - Dominic Cleal
Assignee: Dominic Cleal
Category: Templates
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Pull request: https://github.com/theforeman/foreman/p
ull/3077
Description

With safemode enabled, rendering of the default kickstart_networking_setup snippet fails as some of the lookups (probably
@host.managed_interfaces or similar) are now relations rather than arrays.

2016-01-13T08:40:35 [app] [W] »There was an error rendering the Kickstart default template: «

| ActionView::Template::Error: The snippet 'kickstart_networking_setup' threw an error: undefined
method 'each' for Safemode::Jail (ActiveRecord::AssociationRelation)

| /home/dcleal/code/foreman/foreman/lib/foreman/renderer.rb:75:in ‘rescue in snippet'

| /home/dcleal/code/foreman/foreman/lib/foreman/renderer.rb:72:in " snippet'

| /home/dcleal/.rvm/gems/ruby—-2.0.0-p353@foreman/gems/safemode-1.2.2/1ib/safemode/scope.rb:37:in
"method_missing'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/safemode-1.2.2/1ib/safemode.rb:226:in “bind
T

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/safemode-1.2.2/1ib/safemode.rb:51:in “eval'
| /home/dcleal/.rvm/gems/ruby-2.0.0-p353Q@foreman/gems/safemode-1.2.2/1ib/safemode.rb:51:in “eval'
| /home/dcleal/code/foreman/foreman/lib/foreman/renderer.rb:16:in "“render_safe'

\

/home/dcleal/code/foreman/foreman/lib/foreman/renderer.rb:103:in “unattended_render'

Related issues:
Related to Foreman - Bug #13755: Allow iterating over ActiveRecord Collection... Closed 02/17/2016

Associated revisions

Revision ac735d74 - 01/21/2016 10:13 AM - Dominic Cleal

fixes #13168 - permit safemode templates read-only access to AR relations
Templates such as kickstart_networking_setup use relations of
Host::Managed to access network interfaces. Since Rails 4, these return

relation objects rather than arrays which being core Ruby, had permitted
methods defined in safemode itself.

History

#1 - 01/14/2016 11:03 AM - Dominic Cleal
- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#2 - 01/14/2016 11:20 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3077 added

#3 - 01/21/2016 11:02 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100
Applied in changeset ac735d74fe1e0664d61c6746d526d453511a92f3.

#4 - 02/17/2016 06:53 AM - Marek Hulan

- Related to Bug #13755: Allow iterating over ActiveRecord CollectionProxy in safe mode rendering added
